/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __LOCAL_KPTR_STASH_SKEL_H__
#define __LOCAL_KPTR_STASH_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

struct local_kptr_stash {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *some_nodes;
		struct bpf_map *bss;
	} maps;
	struct {
		struct bpf_program *stash_rb_nodes;
		struct bpf_program *stash_plain;
		struct bpf_program *unstash_rb_node;
		struct bpf_program *stash_test_ref_kfunc;
	} progs;
	struct {
		struct bpf_link *stash_rb_nodes;
		struct bpf_link *stash_plain;
		struct bpf_link *unstash_rb_node;
		struct bpf_link *stash_test_ref_kfunc;
	} links;
	struct local_kptr_stash__bss {
		struct node_data *just_here_because_btf_bug;
	} *bss;

#ifdef __cplusplus
	static inline struct local_kptr_stash *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct local_kptr_stash *open_and_load();
	static inline int load(struct local_kptr_stash *skel);
	static inline int attach(struct local_kptr_stash *skel);
	static inline void detach(struct local_kptr_stash *skel);
	static inline void destroy(struct local_kptr_stash *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
local_kptr_stash__destroy(struct local_kptr_stash *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
local_kptr_stash__create_skeleton(struct local_kptr_stash *obj);

static inline struct local_kptr_stash *
local_kptr_stash__open_opts(const struct bpf_object_open_opts *opts)
{
	struct local_kptr_stash *obj;
	int err;

	obj = (struct local_kptr_stash *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = local_kptr_stash__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	local_kptr_stash__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct local_kptr_stash *
local_kptr_stash__open(void)
{
	return local_kptr_stash__open_opts(NULL);
}

static inline int
local_kptr_stash__load(struct local_kptr_stash *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct local_kptr_stash *
local_kptr_stash__open_and_load(void)
{
	struct local_kptr_stash *obj;
	int err;

	obj = local_kptr_stash__open();
	if (!obj)
		return NULL;
	err = local_kptr_stash__load(obj);
	if (err) {
		local_kptr_stash__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
local_kptr_stash__attach(struct local_kptr_stash *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
local_kptr_stash__detach(struct local_kptr_stash *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *local_kptr_stash__elf_bytes(size_t *sz);

static inline int
local_kptr_stash__create_skeleton(struct local_kptr_stash *obj)
{
	struct bpf_object_skeleton *s;
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "local_kptr_stash";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 2;
	s->map_skel_sz = sizeof(*s->maps);
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt, s->map_skel_sz);
	if (!s->maps) {
		err = -ENOMEM;
		goto err;
	}

	s->maps[0].name = "some_nodes";
	s->maps[0].map = &obj->maps.some_nodes;

	s->maps[1].name = "local_kp.bss";
	s->maps[1].map = &obj->maps.bss;
	s->maps[1].mmaped = (void **)&obj->bss;

	/* programs */
	s->prog_cnt = 4;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "stash_rb_nodes";
	s->progs[0].prog = &obj->progs.stash_rb_nodes;
	s->progs[0].link = &obj->links.stash_rb_nodes;

	s->progs[1].name = "stash_plain";
	s->progs[1].prog = &obj->progs.stash_plain;
	s->progs[1].link = &obj->links.stash_plain;

	s->progs[2].name = "unstash_rb_node";
	s->progs[2].prog = &obj->progs.unstash_rb_node;
	s->progs[2].link = &obj->links.unstash_rb_node;

	s->progs[3].name = "stash_test_ref_kfunc";
	s->progs[3].prog = &obj->progs.stash_test_ref_kfunc;
	s->progs[3].link = &obj->links.stash_test_ref_kfunc;

	s->data = local_kptr_stash__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *local_kptr_stash__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x40\x15\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x0a\0\
\x01\0\0\x2e\x73\x74\x72\x74\x61\x62\0\x2e\x73\x79\x6d\x74\x61\x62\0\x74\x63\0\
\x2e\x6d\x61\x70\x73\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x62\x73\x73\0\x6c\x6f\
\x63\x61\x6c\x5f\x6b\x70\x74\x72\x5f\x73\x74\x61\x73\x68\x2e\x63\0\x4c\x42\x42\
\x30\x5f\x39\0\x4c\x42\x42\x30\x5f\x34\0\x4c\x42\x42\x30\x5f\x38\0\x4c\x42\x42\
\x31\x5f\x34\0\x4c\x42\x42\x32\x5f\x33\0\x4c\x42\x42\x33\x5f\x33\0\x73\x74\x61\
\x73\x68\x5f\x72\x62\x5f\x6e\x6f\x64\x65\x73\0\x73\x6f\x6d\x65\x5f\x6e\x6f\x64\
\x65\x73\0\x62\x70\x66\x5f\x6f\x62\x6a\x5f\x6e\x65\x77\x5f\x69\x6d\x70\x6c\0\
\x62\x70\x66\x5f\x6f\x62\x6a\x5f\x64\x72\x6f\x70\x5f\x69\x6d\x70\x6c\0\x73\x74\
\x61\x73\x68\x5f\x70\x6c\x61\x69\x6e\0\x75\x6e\x73\x74\x61\x73\x68\x5f\x72\x62\
\x5f\x6e\x6f\x64\x65\0\x73\x74\x61\x73\x68\x5f\x74\x65\x73\x74\x5f\x72\x65\x66\
\x5f\x6b\x66\x75\x6e\x63\0\x62\x70\x66\x5f\x6b\x66\x75\x6e\x63\x5f\x63\x61\x6c\
\x6c\x5f\x74\x65\x73\x74\x5f\x72\x65\x6c\x65\x61\x73\x65\0\x5f\x6c\x69\x63\x65\
\x6e\x73\x65\0\x6a\x75\x73\x74\x5f\x68\x65\x72\x65\x5f\x62\x65\x63\x61\x75\x73\
\x65\x5f\x62\x74\x66\x5f\x62\x75\x67\0\x2e\x72\x65\x6c\x74\x63\0\x2e\x42\x54\
\x46\0\x2e\x42\x54\x46\x2e\x65\x78\x74\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x27\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x3a\0\0\0\0\0\x03\0\x98\x01\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x41\0\0\0\0\0\x03\0\xc0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x48\0\0\0\0\0\x03\0\xa0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x4f\0\0\0\0\0\x03\0\
\x80\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x56\0\0\0\0\0\x03\0\x20\x03\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x5d\0\0\0\0\0\x03\0\xb8\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x64\0\0\
\0\x12\0\x03\0\0\0\0\0\0\0\0\0\xb0\x01\0\0\0\0\0\0\x73\0\0\0\x11\0\x04\0\0\0\0\
\0\0\0\0\0\x20\0\0\0\0\0\0\0\x7e\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x8f\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xa1\0\0\0\x12\0\x03\0\
\xb0\x01\0\0\0\0\0\0\xe0\0\0\0\0\0\0\0\xad\0\0\0\x12\0\x03\0\x90\x02\0\0\0\0\0\
\0\xa0\0\0\0\0\0\0\0\xbd\0\0\0\x12\0\x03\0\x30\x03\0\0\0\0\0\0\x98\0\0\0\0\0\0\
\0\xd2\0\0\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xee\0\0\0\x11\0\x05\0\0\
\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\xf7\0\0\0\x11\0\x06\0\0\0\0\0\0\0\0\0\x08\0\0\
\0\0\0\0\0\xb4\x01\0\0\0\0\0\0\x63\x1a\xf8\xff\0\0\0\0\xbf\xa2\0\0\0\0\0\0\x07\
\x02\0\0\xf8\xff\xff\xff\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x01\0\0\
\0\xbf\x06\0\0\0\0\0\0\x15\x06\x2a\0\0\0\0\0\x18\x01\0\0\x12\0\0\0\0\0\0\0\0\0\
\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\x15\0\x25\0\0\0\0\0\xb7\
\x01\0\0\x29\0\0\0\x7b\x10\0\0\0\0\0\0\x07\x06\0\0\x10\0\0\0\xbf\x61\0\0\0\0\0\
\0\xbf\x02\0\0\0\0\0\0\x85\0\0\0\xc2\0\0\0\x15\0\x03\0\0\0\0\0\xbf\x01\0\0\0\0\
\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\xb4\x01\0\0\x01\0\0\0\x63\
\x1a\xfc\xff\0\0\0\0\xbf\xa2\0\0\0\0\0\0\x07\x02\0\0\xfc\xff\xff\xff\x18\x01\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x01\0\0\0\xbf\x07\0\0\0\0\0\0\xb7\x06\0\0\
\x01\0\0\0\x15\x07\x12\0\0\0\0\0\x18\x01\0\0\x12\0\0\0\0\0\0\0\0\0\0\0\xb7\x02\
\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\x15\0\x0d\0\0\0\0\0\xb7\x01\0\0\x2a\0\
\0\0\x7b\x10\0\0\0\0\0\0\x07\x07\0\0\x10\0\0\0\xbf\x71\0\0\0\0\0\0\xbf\x02\0\0\
\0\0\0\0\x85\0\0\0\xc2\0\0\0\xb7\x06\0\0\0\0\0\0\x15\0\x05\0\0\0\0\0\xbf\x01\0\
\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\x05\0\x01\0\0\0\0\0\
\xb7\x06\0\0\x01\0\0\0\xbf\x60\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\xb4\x01\0\0\0\0\0\
\0\x63\x1a\xfc\xff\0\0\0\0\xbf\xa2\0\0\0\0\0\0\x07\x02\0\0\xfc\xff\xff\xff\x18\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x01\0\0\0\xbf\x07\0\0\0\0\0\0\xb7\
\x06\0\0\x01\0\0\0\x15\x07\x10\0\0\0\0\0\x18\x01\0\0\x1c\0\0\0\0\0\0\0\0\0\0\0\
\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\x15\0\x0b\0\0\0\0\0\xb7\x01\0\
\0\x29\0\0\0\x7b\x10\0\0\0\0\0\0\x07\x07\0\0\x18\0\0\0\xbf\x71\0\0\0\0\0\0\xbf\
\x02\0\0\0\0\0\0\x85\0\0\0\xc2\0\0\0\xb7\x06\0\0\0\0\0\0\x15\0\x03\0\0\0\0\0\
\xbf\x01\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\0\xff\xff\xff\xff\xbf\x60\0\
\0\0\0\0\0\x95\0\0\0\0\0\0\0\xb4\x01\0\0\x01\0\0\0\x63\x1a\xfc\xff\0\0\0\0\xbf\
\xa2\0\0\0\0\0\0\x07\x02\0\0\xfc\xff\xff\xff\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x85\0\0\0\x01\0\0\0\xb7\x06\0\0\x01\0\0\0\x15\0\x09\0\0\0\0\0\x07\0\0\0\x10\
\0\0\0\xbf\x01\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\0\0\0\xc2\0\0\0\x15\0\x04\0\
\0\0\0\0\x79\x06\0\0\0\0\0\0\xbf\x01\0\0\0\0\0\0\xb7\x02\0\0\0\0\0\0\x85\x10\0\
\0\xff\xff\xff\xff\xbf\x60\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\xb4\x01\0\0\0\0\0\0\
\x63\x1a\xfc\xff\0\0\0\0\xbf\xa2\0\0\0\0\0\0\x07\x02\0\0\xfc\xff\xff\xff\x18\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x85\0\0\0\x01\0\0\0\xb7\x06\0\0\x01\0\0\0\x15\
\0\x08\0\0\0\0\0\x07\0\0\0\x08\0\0\0\xb7\x06\0\0\0\0\0\0\xbf\x01\0\0\0\0\0\0\
\xb7\x02\0\0\0\0\0\0\x85\0\0\0\xc2\0\0\0\x15\0\x02\0\0\0\0\0\xbf\x01\0\0\0\0\0\
\0\x85\x10\0\0\xff\xff\xff\xff\xbf\x60\0\0\0\0\0\0\x95\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x47\x50\x4c\0\0\0\0\0\
\x20\0\0\0\0\0\0\0\x01\0\0\0\x0a\0\0\0\x60\0\0\0\0\0\0\0\x0a\0\0\0\x0b\0\0\0\
\xb8\0\0\0\0\0\0\0\x0a\0\0\0\x0c\0\0\0\xe0\0\0\0\0\0\0\0\x01\0\0\0\x0a\0\0\0\
\x28\x01\0\0\0\0\0\0\x0a\0\0\0\x0b\0\0\0\x88\x01\0\0\0\0\0\0\x0a\0\0\0\x0c\0\0\
\0\xd0\x01\0\0\0\0\0\0\x01\0\0\0\x0a\0\0\0\x18\x02\0\0\0\0\0\0\x0a\0\0\0\x0b\0\
\0\0\x78\x02\0\0\0\0\0\0\x0a\0\0\0\x0c\0\0\0\xb0\x02\0\0\0\0\0\0\x01\0\0\0\x0a\
\0\0\0\x18\x03\0\0\0\0\0\0\x0a\0\0\0\x0c\0\0\0\x50\x03\0\0\0\0\0\0\x01\0\0\0\
\x0a\0\0\0\xb0\x03\0\0\0\0\0\0\x0a\0\0\0\x10\0\0\0\x9f\xeb\x01\0\x18\0\0\0\0\0\
\0\0\x1c\x04\0\0\x1c\x04\0\0\x32\x05\0\0\0\0\0\0\0\0\0\x02\x03\0\0\0\x01\0\0\0\
\0\0\0\x01\x04\0\0\0\x20\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x02\0\0\0\x04\0\0\0\
\x02\0\0\0\x05\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\x02\x02\0\0\0\
\0\0\0\0\0\0\0\x02\x07\0\0\0\x19\0\0\0\x04\0\0\x04\x20\0\0\0\x23\0\0\0\x08\0\0\
\0\0\0\0\0\x2c\0\0\0\x09\0\0\0\x40\0\0\0\x30\0\0\0\x0a\0\0\0\x80\0\0\0\x35\0\0\
\0\x0b\0\0\0\xc0\0\0\0\0\0\0\0\0\0\0\x02\x1f\0\0\0\0\0\0\0\0\0\0\x02\x2e\0\0\0\
\0\0\0\0\0\0\0\x02\x2c\0\0\0\0\0\0\0\0\0\0\x02\x2d\0\0\0\0\0\0\0\x04\0\0\x04\
\x20\0\0\0\x3b\0\0\0\x01\0\0\0\0\0\0\0\x40\0\0\0\x05\0\0\0\x40\0\0\0\x44\0\0\0\
\x06\0\0\0\x80\0\0\0\x4a\0\0\0\x01\0\0\0\xc0\0\0\0\x56\0\0\0\0\0\0\x0e\x0c\0\0\
\0\x01\0\0\0\0\0\0\0\0\0\0\x02\0\0\0\0\0\0\0\0\x01\0\0\x0d\x10\0\0\0\x61\0\0\0\
\x0e\0\0\0\x65\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\x01\x6a\0\0\0\x01\0\0\x0c\x0f\
\0\0\0\x79\0\0\0\x03\0\0\x04\x30\0\0\0\x40\0\0\0\x10\0\0\0\0\0\0\0\x83\0\0\0\
\x10\0\0\0\x40\0\0\0\x30\0\0\0\x13\0\0\0\x80\0\0\0\x88\0\0\0\0\0\0\x04\x20\0\0\
\0\0\0\0\0\x02\0\0\x0d\x0e\0\0\0\0\0\0\0\x15\0\0\0\0\0\0\0\x0e\0\0\0\x94\0\0\0\
\0\0\0\x08\x16\0\0\0\x9a\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\0\xad\0\0\0\x02\0\0\
\x0c\x14\0\0\0\0\0\0\0\x02\0\0\x0d\0\0\0\0\0\0\0\0\x0e\0\0\0\0\0\0\0\x0e\0\0\0\
\xbe\0\0\0\x02\0\0\x0c\x18\0\0\0\xd0\0\0\0\x01\0\0\x0c\x0f\0\0\0\xdc\0\0\0\x02\
\0\0\x04\x10\0\0\0\x40\0\0\0\x10\0\0\0\0\0\0\0\x83\0\0\0\x10\0\0\0\x40\0\0\0\
\xe8\0\0\0\x01\0\0\x0c\x0f\0\0\0\xf8\0\0\0\x01\0\0\x0c\x0f\0\0\0\0\0\0\0\x01\0\
\0\x0d\0\0\0\0\0\0\0\0\x08\0\0\0\x0d\x01\0\0\x05\0\0\x04\x20\0\0\0\x21\x01\0\0\
\x02\0\0\0\0\0\0\0\x23\x01\0\0\x02\0\0\0\x20\0\0\0\x25\x01\0\0\x20\0\0\0\x40\0\
\0\0\x2a\x01\0\0\x08\0\0\0\x80\0\0\0\x2f\x01\0\0\x22\0\0\0\xc0\0\0\0\x33\x01\0\
\0\x02\0\0\x04\x08\0\0\0\x44\x01\0\0\x21\0\0\0\0\0\0\0\x46\x01\0\0\x02\0\0\0\
\x20\0\0\0\x48\x01\0\0\x01\0\0\x04\x04\0\0\0\x21\x01\0\0\x02\0\0\0\0\0\0\0\x5a\
\x01\0\0\0\0\0\x08\x23\0\0\0\x65\x01\0\0\x01\0\0\x04\x04\0\0\0\x75\x01\0\0\x24\
\0\0\0\0\0\0\0\x7a\x01\0\0\0\0\0\x08\x25\0\0\0\0\0\0\0\x01\0\0\x04\x04\0\0\0\
\x83\x01\0\0\x02\0\0\0\0\0\0\0\x8b\x01\0\0\x02\0\0\x0c\x1e\0\0\0\xa7\x01\0\0\0\
\0\0\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x27\0\0\0\x04\0\0\0\
\x04\0\0\0\xac\x01\0\0\0\0\0\x0e\x28\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\x02\x12\0\0\
\0\xb5\x01\0\0\0\0\0\x0e\x2a\0\0\0\x01\0\0\0\xcf\x01\0\0\0\0\0\x12\x12\0\0\0\
\xcf\x01\0\0\0\0\0\x12\x1b\0\0\0\xcf\x01\0\0\0\0\0\x12\x1f\0\0\0\x15\x05\0\0\
\x01\0\0\x0f\x20\0\0\0\x0d\0\0\0\0\0\0\0\x20\0\0\0\x1b\x05\0\0\x01\0\0\x0f\x04\
\0\0\0\x29\0\0\0\0\0\0\0\x04\0\0\0\x23\x05\0\0\x01\0\0\x0f\x08\0\0\0\x2b\0\0\0\
\0\0\0\0\x08\0\0\0\x28\x05\0\0\x03\0\0\x0f\0\0\0\0\x17\0\0\0\0\0\0\0\0\0\0\0\
\x19\0\0\0\0\0\0\0\0\0\0\0\x26\0\0\0\0\0\0\0\0\0\0\0\0\x69\x6e\x74\0\x5f\x5f\
\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x6d\x61\
\x70\x5f\x76\x61\x6c\x75\x65\0\x6e\x6f\x74\x5f\x6b\x70\x74\x72\0\x76\x61\x6c\0\
\x6e\x6f\x64\x65\0\x70\x6c\x61\x69\x6e\0\x74\x79\x70\x65\0\x6b\x65\x79\0\x76\
\x61\x6c\x75\x65\0\x6d\x61\x78\x5f\x65\x6e\x74\x72\x69\x65\x73\0\x73\x6f\x6d\
\x65\x5f\x6e\x6f\x64\x65\x73\0\x63\x74\x78\0\x6c\x6f\x6e\x67\0\x73\x74\x61\x73\
\x68\x5f\x72\x62\x5f\x6e\x6f\x64\x65\x73\0\x6e\x6f\x64\x65\x5f\x64\x61\x74\x61\
\0\x64\x61\x74\x61\0\x62\x70\x66\x5f\x72\x62\x5f\x6e\x6f\x64\x65\0\x5f\x5f\x75\
\x36\x34\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\x6e\x67\x20\x6c\x6f\x6e\
\x67\0\x62\x70\x66\x5f\x6f\x62\x6a\x5f\x6e\x65\x77\x5f\x69\x6d\x70\x6c\0\x62\
\x70\x66\x5f\x6f\x62\x6a\x5f\x64\x72\x6f\x70\x5f\x69\x6d\x70\x6c\0\x73\x74\x61\
\x73\x68\x5f\x70\x6c\x61\x69\x6e\0\x70\x6c\x61\x69\x6e\x5f\x6c\x6f\x63\x61\x6c\
\0\x75\x6e\x73\x74\x61\x73\x68\x5f\x72\x62\x5f\x6e\x6f\x64\x65\0\x73\x74\x61\
\x73\x68\x5f\x74\x65\x73\x74\x5f\x72\x65\x66\x5f\x6b\x66\x75\x6e\x63\0\x70\x72\
\x6f\x67\x5f\x74\x65\x73\x74\x5f\x72\x65\x66\x5f\x6b\x66\x75\x6e\x63\0\x61\0\
\x62\0\x6d\x65\x6d\x62\0\x6e\x65\x78\x74\0\x63\x6e\x74\0\x70\x72\x6f\x67\x5f\
\x74\x65\x73\x74\x5f\x6d\x65\x6d\x62\x65\x72\0\x6d\0\x63\0\x70\x72\x6f\x67\x5f\
\x74\x65\x73\x74\x5f\x6d\x65\x6d\x62\x65\x72\x31\0\x72\x65\x66\x63\x6f\x75\x6e\
\x74\x5f\x74\0\x72\x65\x66\x63\x6f\x75\x6e\x74\x5f\x73\x74\x72\x75\x63\x74\0\
\x72\x65\x66\x73\0\x61\x74\x6f\x6d\x69\x63\x5f\x74\0\x63\x6f\x75\x6e\x74\x65\
\x72\0\x62\x70\x66\x5f\x6b\x66\x75\x6e\x63\x5f\x63\x61\x6c\x6c\x5f\x74\x65\x73\
\x74\x5f\x72\x65\x6c\x65\x61\x73\x65\0\x63\x68\x61\x72\0\x5f\x6c\x69\x63\x65\
\x6e\x73\x65\0\x6a\x75\x73\x74\x5f\x68\x65\x72\x65\x5f\x62\x65\x63\x61\x75\x73\
\x65\x5f\x62\x74\x66\x5f\x62\x75\x67\0\x6b\x70\x74\x72\0\x2f\x62\x75\x69\x6c\
\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\
\x72\x6e\x65\x6c\x2d\x35\x2e\x31\x34\x2e\x30\x2d\x34\x36\x36\x2e\x34\x31\x38\
\x2e\x65\x6c\x39\x69\x76\x2f\x6c\x69\x6e\x75\x78\x2d\x35\x2e\x31\x34\x2e\x30\
\x2d\x34\x36\x36\x2e\x34\x31\x38\x2e\x65\x6c\x39\x69\x76\x2e\x78\x38\x36\x5f\
\x36\x34\x2f\x74\x6f\x6f\x6c\x73\x2f\x74\x65\x73\x74\x69\x6e\x67\x2f\x73\x65\
\x6c\x66\x74\x65\x73\x74\x73\x2f\x62\x70\x66\x2f\x70\x72\x6f\x67\x73\x2f\x6c\
\x6f\x63\x61\x6c\x5f\x6b\x70\x74\x72\x5f\x73\x74\x61\x73\x68\x2e\x63\0\x6c\x6f\
\x6e\x67\x20\x73\x74\x61\x73\x68\x5f\x72\x62\x5f\x6e\x6f\x64\x65\x73\x28\x76\
\x6f\x69\x64\x20\x2a\x63\x74\x78\x29\0\x09\x6d\x61\x70\x76\x61\x6c\x20\x3d\x20\
\x62\x70\x66\x5f\x6d\x61\x70\x5f\x6c\x6f\x6f\x6b\x75\x70\x5f\x65\x6c\x65\x6d\
\x28\x26\x73\x6f\x6d\x65\x5f\x6e\x6f\x64\x65\x73\x2c\x20\x26\x69\x64\x78\x29\
\x3b\0\x09\x69\x66\x20\x28\x21\x6d\x61\x70\x76\x61\x6c\x29\0\x09\x72\x65\x73\
\x20\x3d\x20\x62\x70\x66\x5f\x6f\x62\x6a\x5f\x6e\x65\x77\x28\x74\x79\x70\x65\
\x6f\x66\x28\x2a\x72\x65\x73\x29\x29\x3b\0\x09\x69\x66\x20\x28\x21\x72\x65\x73\
\x29\0\x09\x72\x65\x73\x2d\x3e\x6b\x65\x79\x20\x3d\x20\x76\x61\x6c\x3b\0\x09\
\x72\x65\x73\x20\x3d\x20\x62\x70\x66\x5f\x6b\x70\x74\x72\x5f\x78\x63\x68\x67\
\x28\x26\x6d\x61\x70\x76\x61\x6c\x2d\x3e\x6e\x6f\x64\x65\x2c\x20\x72\x65\x73\
\x29\x3b\0\x09\x69\x66\x20\x28\x72\x65\x73\x29\0\x09\x09\x62\x70\x66\x5f\x6f\
\x62\x6a\x5f\x64\x72\x6f\x70\x28\x72\x65\x73\x29\x3b\0\x09\x72\x65\x74\x75\x72\
\x6e\x20\x63\x72\x65\x61\x74\x65\x5f\x61\x6e\x64\x5f\x73\x74\x61\x73\x68\x28\
\x30\x2c\x20\x34\x31\x29\x20\x3f\x3a\x20\x63\x72\x65\x61\x74\x65\x5f\x61\x6e\
\x64\x5f\x73\x74\x61\x73\x68\x28\x31\x2c\x20\x34\x32\x29\x3b\0\x6c\x6f\x6e\x67\
\x20\x73\x74\x61\x73\x68\x5f\x70\x6c\x61\x69\x6e\x28\x76\x6f\x69\x64\x20\x2a\
\x63\x74\x78\x29\0\x09\x69\x6e\x74\x20\x69\x64\x78\x20\x3d\x20\x30\x3b\0\x09\
\x72\x65\x73\x2d\x3e\x6b\x65\x79\x20\x3d\x20\x34\x31\x3b\0\x09\x72\x65\x73\x20\
\x3d\x20\x62\x70\x66\x5f\x6b\x70\x74\x72\x5f\x78\x63\x68\x67\x28\x26\x6d\x61\
\x70\x76\x61\x6c\x2d\x3e\x70\x6c\x61\x69\x6e\x2c\x20\x72\x65\x73\x29\x3b\0\x7d\
\0\x6c\x6f\x6e\x67\x20\x75\x6e\x73\x74\x61\x73\x68\x5f\x72\x62\x5f\x6e\x6f\x64\
\x65\x28\x76\x6f\x69\x64\x20\x2a\x63\x74\x78\x29\0\x09\x69\x6e\x74\x20\x6b\x65\
\x79\x20\x3d\x20\x31\x3b\0\x09\x6d\x61\x70\x76\x61\x6c\x20\x3d\x20\x62\x70\x66\
\x5f\x6d\x61\x70\x5f\x6c\x6f\x6f\x6b\x75\x70\x5f\x65\x6c\x65\x6d\x28\x26\x73\
\x6f\x6d\x65\x5f\x6e\x6f\x64\x65\x73\x2c\x20\x26\x6b\x65\x79\x29\x3b\0\x09\x72\
\x65\x73\x20\x3d\x20\x62\x70\x66\x5f\x6b\x70\x74\x72\x5f\x78\x63\x68\x67\x28\
\x26\x6d\x61\x70\x76\x61\x6c\x2d\x3e\x6e\x6f\x64\x65\x2c\x20\x4e\x55\x4c\x4c\
\x29\x3b\0\x09\x69\x66\x20\x28\x72\x65\x73\x29\x20\x7b\0\x09\x09\x72\x65\x74\
\x76\x61\x6c\x20\x3d\x20\x72\x65\x73\x2d\x3e\x6b\x65\x79\x3b\0\x6c\x6f\x6e\x67\
\x20\x73\x74\x61\x73\x68\x5f\x74\x65\x73\x74\x5f\x72\x65\x66\x5f\x6b\x66\x75\
\x6e\x63\x28\x76\x6f\x69\x64\x20\x2a\x63\x74\x78\x29\0\x09\x69\x6e\x74\x20\x6b\
\x65\x79\x20\x3d\x20\x30\x3b\0\x09\x72\x65\x73\x20\x3d\x20\x62\x70\x66\x5f\x6b\
\x70\x74\x72\x5f\x78\x63\x68\x67\x28\x26\x6d\x61\x70\x76\x61\x6c\x2d\x3e\x76\
\x61\x6c\x2c\x20\x4e\x55\x4c\x4c\x29\x3b\0\x09\x09\x62\x70\x66\x5f\x6b\x66\x75\
\x6e\x63\x5f\x63\x61\x6c\x6c\x5f\x74\x65\x73\x74\x5f\x72\x65\x6c\x65\x61\x73\
\x65\x28\x72\x65\x73\x29\x3b\0\x30\0\x2e\x6d\x61\x70\x73\0\x6c\x69\x63\x65\x6e\
\x73\x65\0\x2e\x62\x73\x73\0\x2e\x6b\x73\x79\x6d\x73\0\x74\x63\0\0\0\x9f\xeb\
\x01\0\x20\0\0\0\0\0\0\0\x2c\0\0\0\x2c\0\0\0\x5c\x03\0\0\x88\x03\0\0\x3c\0\0\0\
\x08\0\0\0\x2f\x05\0\0\x04\0\0\0\0\0\0\0\x11\0\0\0\xb0\x01\0\0\x1a\0\0\0\x90\
\x02\0\0\x1c\0\0\0\x30\x03\0\0\x1d\0\0\0\x10\0\0\0\x2f\x05\0\0\x35\0\0\0\0\0\0\
\0\xd4\x01\0\0\x5d\x02\0\0\0\x18\x01\0\x18\0\0\0\xd4\x01\0\0\0\0\0\0\0\0\0\0\
\x20\0\0\0\xd4\x01\0\0\x7c\x02\0\0\x0b\xd8\0\0\x40\0\0\0\xd4\x01\0\0\xae\x02\0\
\0\x06\xdc\0\0\x48\0\0\0\xd4\x01\0\0\xbc\x02\0\0\x08\xe8\0\0\x68\0\0\0\xd4\x01\
\0\0\xde\x02\0\0\x06\xec\0\0\x78\0\0\0\xd4\x01\0\0\xe9\x02\0\0\x0b\xf4\0\0\x80\
\0\0\0\xd4\x01\0\0\xfa\x02\0\0\x1f\xfc\0\0\x88\0\0\0\xd4\x01\0\0\xfa\x02\0\0\
\x08\xfc\0\0\xa0\0\0\0\xd4\x01\0\0\x24\x03\0\0\x06\0\x01\0\xa8\0\0\0\xd4\x01\0\
\0\x2e\x03\0\0\x03\x04\x01\0\xd8\0\0\0\xd4\x01\0\0\0\0\0\0\0\0\0\0\xe0\0\0\0\
\xd4\x01\0\0\x7c\x02\0\0\x0b\xd8\0\0\x08\x01\0\0\xd4\x01\0\0\xae\x02\0\0\x06\
\xdc\0\0\x10\x01\0\0\xd4\x01\0\0\xbc\x02\0\0\x08\xe8\0\0\x30\x01\0\0\xd4\x01\0\
\0\xde\x02\0\0\x06\xec\0\0\x40\x01\0\0\xd4\x01\0\0\xe9\x02\0\0\x0b\xf4\0\0\x48\
\x01\0\0\xd4\x01\0\0\xfa\x02\0\0\x1f\xfc\0\0\x50\x01\0\0\xd4\x01\0\0\xfa\x02\0\
\0\x08\xfc\0\0\x70\x01\0\0\xd4\x01\0\0\x24\x03\0\0\x06\0\x01\0\x78\x01\0\0\xd4\
\x01\0\0\x2e\x03\0\0\x03\x04\x01\0\xa0\x01\0\0\xd4\x01\0\0\x43\x03\0\0\x02\x20\
\x01\0\xb0\x01\0\0\xd4\x01\0\0\x7f\x03\0\0\0\x30\x01\0\xb8\x01\0\0\xd4\x01\0\0\
\x9b\x03\0\0\x06\x40\x01\0\xd0\x01\0\0\xd4\x01\0\0\x7c\x02\0\0\x0b\x48\x01\0\
\xf8\x01\0\0\xd4\x01\0\0\xae\x02\0\0\x06\x4c\x01\0\0\x02\0\0\xd4\x01\0\0\xbc\
\x02\0\0\x08\x58\x01\0\x20\x02\0\0\xd4\x01\0\0\xde\x02\0\0\x06\x5c\x01\0\x30\
\x02\0\0\xd4\x01\0\0\xa9\x03\0\0\x0b\x64\x01\0\x38\x02\0\0\xd4\x01\0\0\xb9\x03\
\0\0\x1f\x6c\x01\0\x40\x02\0\0\xd4\x01\0\0\xb9\x03\0\0\x08\x6c\x01\0\x60\x02\0\
\0\xd4\x01\0\0\x24\x03\0\0\x06\x70\x01\0\x68\x02\0\0\xd4\x01\0\0\x2e\x03\0\0\
\x03\x74\x01\0\x80\x02\0\0\xd4\x01\0\0\xe4\x03\0\0\x01\x7c\x01\0\x90\x02\0\0\
\xd4\x01\0\0\xe6\x03\0\0\0\x88\x01\0\x98\x02\0\0\xd4\x01\0\0\x06\x04\0\0\x06\
\x9c\x01\0\xb0\x02\0\0\xd4\x01\0\0\x14\x04\0\0\x0b\xa4\x01\0\xd0\x02\0\0\xd4\
\x01\0\0\xae\x02\0\0\x06\xa8\x01\0\xd8\x02\0\0\xd4\x01\0\0\x46\x04\0\0\x1f\xb4\
\x01\0\xe0\x02\0\0\xd4\x01\0\0\x46\x04\0\0\x08\xb4\x01\0\xf8\x02\0\0\xd4\x01\0\
\0\x71\x04\0\0\x06\xb8\x01\0\0\x03\0\0\xd4\x01\0\0\x7d\x04\0\0\x11\xbc\x01\0\
\x08\x03\0\0\xd4\x01\0\0\x2e\x03\0\0\x03\xc0\x01\0\x20\x03\0\0\xd4\x01\0\0\xe4\
\x03\0\0\x01\xd0\x01\0\x30\x03\0\0\xd4\x01\0\0\x92\x04\0\0\0\xdc\x01\0\x38\x03\
\0\0\xd4\x01\0\0\xb7\x04\0\0\x06\xec\x01\0\x50\x03\0\0\xd4\x01\0\0\x14\x04\0\0\
\x0b\xf4\x01\0\x70\x03\0\0\xd4\x01\0\0\xae\x02\0\0\x06\xf8\x01\0\x78\x03\0\0\
\xd4\x01\0\0\xc5\x04\0\0\x1f\x04\x02\0\x88\x03\0\0\xd4\x01\0\0\xc5\x04\0\0\x08\
\x04\x02\0\xa0\x03\0\0\xd4\x01\0\0\x24\x03\0\0\x06\x08\x02\0\xa8\x03\0\0\xd4\
\x01\0\0\xef\x04\0\0\x03\x0c\x02\0\xb8\x03\0\0\xd4\x01\0\0\xe4\x03\0\0\x01\x14\
\x02\0\x10\0\0\0\x2f\x05\0\0\x03\0\0\0\x48\0\0\0\x12\0\0\0\x13\x05\0\0\x06\0\0\
\0\x10\x01\0\0\x12\0\0\0\x13\x05\0\0\x06\0\0\0\0\x02\0\0\x1b\0\0\0\x13\x05\0\0\
\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\
\x03\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\x26\x01\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x09\0\0\0\x02\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x68\x01\0\0\0\0\0\0\xc8\x01\0\0\0\0\0\0\x01\0\0\0\
\0\0\0\0\x08\0\0\0\0\0\0\0\x18\0\0\0\0\0\0\0\x11\0\0\0\x01\0\0\0\x06\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x30\x03\0\0\0\0\0\0\xc8\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x14\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\xf8\x06\0\0\0\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x1a\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x18\
\x07\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\x22\0\0\0\x08\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x20\x07\0\0\0\0\0\
\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x11\x01\
\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x20\x07\0\0\0\0\0\0\xd0\0\0\0\
\0\0\0\0\x02\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x18\x01\0\0\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xf0\x07\0\0\0\0\0\0\x66\x09\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x1d\x01\0\0\x01\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x58\x11\0\0\0\0\0\0\xe4\x03\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct local_kptr_stash *local_kptr_stash::open(const struct bpf_object_open_opts *opts) { return local_kptr_stash__open_opts(opts); }
struct local_kptr_stash *local_kptr_stash::open_and_load() { return local_kptr_stash__open_and_load(); }
int local_kptr_stash::load(struct local_kptr_stash *skel) { return local_kptr_stash__load(skel); }
int local_kptr_stash::attach(struct local_kptr_stash *skel) { return local_kptr_stash__attach(skel); }
void local_kptr_stash::detach(struct local_kptr_stash *skel) { local_kptr_stash__detach(skel); }
void local_kptr_stash::destroy(struct local_kptr_stash *skel) { local_kptr_stash__destroy(skel); }
const void *local_kptr_stash::elf_bytes(size_t *sz) { return local_kptr_stash__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
local_kptr_stash__assert(struct local_kptr_stash *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
	_Static_assert(sizeof(s->bss->just_here_because_btf_bug) == 8, "unexpected size of 'just_here_because_btf_bug'");
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __LOCAL_KPTR_STASH_SKEL_H__ */
